//+------------------------------------------------------------------+
//|                                           TP_ServerUang_v1_0.mq4 |
//|                                                       ServerUang |
//|                                    http://www.indofx-trader.net/ |
//+------------------------------------------------------------------+
#property copyright "ServerUang"
#property link      "http://www.indofx-trader.net/"

#property indicator_separate_window

extern string Color_Settings = "--------------------------";
extern color TextColor = White;
extern color TP1_color = Lime;
extern color TP2_color = White;
extern color TP3_color = Yellow;

// BuySeLL Variable
extern string BuySeLL_Settings = "--------------------------";
extern int TimeFrame = 0;
extern int MAFastPeriod = 4; 
extern int MAFastMethod = 3; 
extern int MAFastApply_To = 0;
extern int MAFastShift = 0;

extern int MASlowPeriod = 4; 
extern int MASlowMethod = 3;
extern int MASlowApply_To = 1;
extern int MASlowShift = 0;


string WindowName = "TP_ServerUang_v1_0"; // Jika melakukan perubahan nomor versi, bagian ini harap diubah
string OpenStatus="", textTP="";
double vA, vB, LastHigh, LastLow, x, n, hrg, sprd;
double TP1, TP2, TP3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int z = ObjectsTotal() - 1; z >= 0; z--)
     {
       string label = ObjectName(z);
       if(StringSubstr(label, 0, 4) != "TPSU")
           continue;
       ObjectDelete(label);   
     }   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----

   //---- Name for DataWindow and indicator subwindow label
   IndicatorShortName(WindowName); 
   SetIndexDrawBegin(0,1);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));

   int counted_bars = IndicatorCounted();
   int limit, i;
   
   //---- Indicator Calculation ----
   if(counted_bars == 0)
     {
       x = Period();
       if(x > 240) 
           return(-1);       
     }
   if(counted_bars < 0) 
       return(-1);
   //---- last counted bar will be recounted
   //   if(counted_bars>0) counted_bars--;
   limit = (Bars - counted_bars) - 1;
 
   // ------------------- 
   // ---   AWAL AWAS ---
   // -------------------
   for(i = limit; i >= 0; i--)
     { 
       if(High[i+1] > LastHigh) 
           LastHigh = High[i+1];
       
       if(Low[i+1] < LastLow) 
           LastLow=Low[i+1];
       
       if(TimeDay(Time[i]) != TimeDay(Time[i+1]))
         { 
           LastLow = Open[i]; 
           LastHigh = Open[i];
         }
         
       //---- Pivot Setup ----
       double rates[1][6],yesterday_volume,yesterday_close,yesterday_high,yesterday_low,yesterday_open;
       ArrayCopyRates(rates, Symbol(), PERIOD_D1);

       if(DayOfWeek() == 1)
          {
           if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,1)) == 5)
              {
               yesterday_volume = rates[1][5];
               yesterday_close = rates[1][4];
               yesterday_high = rates[1][3];
               yesterday_low = rates[1][2];
               yesterday_open = rates[1][1];
       
              }
           else
              {
               for(int d = 5;d>=0;d--)
                   {
                    if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,d)) == 5)
                       {
                        yesterday_volume = rates[d][5];
                        yesterday_close = rates[d][4];
                        yesterday_high = rates[d][3];
                        yesterday_low = rates[d][2];
                        yesterday_open = rates[d][1];
                       }
         
                   }  
      
              }
          }
       else
          {
           yesterday_close = rates[1][4];
           yesterday_high = rates[1][3];
           yesterday_low = rates[1][2];
           yesterday_open = rates[1][1];
          }

       //---- Calculate Pivots ----
       double R = yesterday_high - yesterday_low;//range
       double p = (yesterday_high + yesterday_low + yesterday_close)/3;// Standard Pivot
       double r3 = (2*p)+(yesterday_high-(2*yesterday_low));// Resistance 3
       double r2 = p+(yesterday_high - yesterday_low);// Resistance point 2
       double r1 = (2*p)-yesterday_low;// Resistance point 1
       double s1 = (2*p)-yesterday_high;// Support point 1
       double s2 = p-(yesterday_high - yesterday_low);// Support point 2
       double s3 = (2*p)-((2* yesterday_high)-yesterday_low);// Support point 3

       double m0 = (s2 + s3)/2;
       double m1 = (s1 + s2)/2;
       double m2 = (p + s1)/2;
       double m3 = (p + r1)/2; 
       double m4 = (r1 + r2)/2;
       double m5 = (r2 + r3)/2; 
     } // end for
          
   // --------------------
   // ---   AKHIR AWAS ---
   // --------------------
      
   vA = iMA(Symbol(), TimeFrame, MAFastPeriod, MAFastShift, MAFastMethod, MAFastApply_To, 0);
   vB = iMA(Symbol(), TimeFrame, MASlowPeriod, MASlowShift, MASlowMethod, MASlowApply_To, 0);
   if (vA>vB)
       { OpenStatus="BUY" ;}
   else { OpenStatus="SELL" ;}
   //Write_SW("TPSU01", 0, 10, 20, Symbol()+ " TF H1 Open Status " + OpenStatus, 10, "Arial", TextColor);
   
   // --- TARGETTING ---
   sprd=(Ask - Bid);
   hrg=iMA(Symbol(),0,1,0,MODE_EMA,PRICE_CLOSE,0); //hrg=price
   // Jika status open = BUY
   if (OpenStatus=="BUY")
       {
         TP1=0; TP2=0; TP3=0;
         if (hrg>(r3))                  {TP1=r3+(2*sprd); TP2=r3+(3*sprd); TP3=r3+(4*sprd);}
         else if (hrg==(r3))            {TP1=r3+(2*sprd); TP2=r3+(3*sprd); TP3=r3+(4*sprd);}
         else if ((hrg<r3) && (hrg>m5)) {TP1=r3; TP2=r3+(2*sprd); TP3=r3+(3*sprd);}
         else if ((hrg==m5))            {TP1=r3; TP2=r3+(2*sprd); TP3=r3+(3*sprd);}
         else if ((hrg<m5) && (hrg>r2)) {TP1=m5; TP2=r3; TP3=r3+(2*sprd);}
         else if ((hrg==r2))            {TP1=m5; TP2=r3; TP3=r3+(2*sprd);}
         else if ((hrg<r2) && (hrg>m4)) {TP1=r2; TP2=m5; TP3=r3;}
         else if ((hrg==m4))            {TP1=r2; TP2=m5; TP3=r3;}
         else if ((hrg<m4) && (hrg>r1)) {TP1=m4; TP2=r2; TP3=m5;}
         else if ((hrg==r1))            {TP1=m4; TP2=r2; TP3=m5;}
         else if ((hrg<r1) && (hrg>m3)) {TP1=r1; TP2=m4; TP3=r2;}
         else if ((hrg==m3))            {TP1=r1; TP2=m4; TP3=r2;}
         else if ((hrg<m3) && (hrg>p))  {TP1=m3; TP2=r1; TP3=m4;}
         else if ((hrg==p))             {TP1=m3; TP2=r1; TP3=m4;}
         else if ((hrg<p) && (hrg>m2))  {TP1=p; TP2=m3; TP3=r1;}
         else if ((hrg==m2))            {TP1=p; TP2=m3; TP3=r1;}
         else if ((hrg<m2) && (hrg>s1)) {TP1=m2; TP2=p; TP3=m3;}
         else if ((hrg==s1))            {TP1=m2; TP2=p; TP3=m3;}
         else if ((hrg<s1) && (hrg>m1)) {TP1=s1; TP2=m2; TP3=p;}
         else if ((hrg==m1))            {TP1=s1; TP2=m2; TP3=p;}
         else if ((hrg<m1) && (hrg>s2)) {TP1=m1; TP2=s1; TP3=m2;}
         else if ((hrg==s2))            {TP1=m1; TP2=s1; TP3=m2;}
         else if ((hrg<s2) && (hrg>m0)) {TP1=s2; TP2=m1; TP3=s1;}
         else if ((hrg==m0))            {TP1=s2; TP2=m1; TP3=s1;}
         else if ((hrg<m0) && (hrg>s3)) {TP1=m0; TP2=s2; TP3=m1;}
         else if ((hrg==s3))            {TP1=m0; TP2=s2; TP3=m1;}
         else if ((hrg<s3))             {TP1=s3; TP2=m0; TP3=s2;}
       }
   // Jika status open = SELL
   else
       {
         TP1=0; TP2=0; TP3=0;
         if (hrg>(r3))                  {TP1=r3; TP2=m5; TP3=r2;}
         else if (hrg==(r3))            {TP1=m5; TP2=r2; TP3=m4;}
         else if ((hrg<r3) && (hrg>m5)) {TP1=m5; TP2=r2; TP3=m4;}
         else if ((hrg==m5))            {TP1=r2; TP2=m4; TP3=r1;}
         else if ((hrg<m5) && (hrg>r2)) {TP1=r2; TP2=m4; TP3=r1;}
         else if ((hrg==r2))            {TP1=m4; TP2=r1; TP3=m3;}
         else if ((hrg<r2) && (hrg>m4)) {TP1=m4; TP2=r1; TP3=m3;}
         else if ((hrg==m4))            {TP1=r1; TP2=m3; TP3=p;}
         else if ((hrg<m4) && (hrg>r1)) {TP1=r1; TP2=m3; TP3=p;}
         else if ((hrg==r1))            {TP1=m3; TP2=p; TP3=m2;}
         else if ((hrg<r1) && (hrg>m3)) {TP1=m3; TP2=p; TP3=m2;}
         else if ((hrg==m3))            {TP1=p; TP2=m2; TP3=s1;}
         else if ((hrg<m3) && (hrg>p))  {TP1=p; TP2=m2; TP3=s1;}
         else if ((hrg==p))             {TP1=m2; TP2=s1; TP3=m1;}
         else if ((hrg<p) && (hrg>m2))  {TP1=m2; TP2=s1; TP3=m1;}
         else if ((hrg==m2))            {TP1=s1; TP2=m1; TP3=s2;}
         else if ((hrg<m2) && (hrg>s1)) {TP1=s1; TP2=m1; TP3=s2;}
         else if ((hrg==s1))            {TP1=m1; TP2=s2; TP3=m0;}
         else if ((hrg<s1) && (hrg>m1)) {TP1=m1; TP2=s2; TP3=m0;}
         else if ((hrg==m1))            {TP1=s2; TP2=m0; TP3=s3;}
         else if ((hrg<m1) && (hrg>s2)) {TP1=s2; TP2=m0; TP3=s3;}
         else if ((hrg==s2))            {TP1=m0; TP2=s3; TP3=s3-(2*sprd);}
         else if ((hrg<s2) && (hrg>m0)) {TP1=m0; TP2=s3; TP3=s3-(2*sprd);}
         else if ((hrg==m0))            {TP1=s3; TP2=s3-(2*sprd); TP3=s3-(3*sprd);}
         else if ((hrg<m0) && (hrg>s3)) {TP1=s3; TP2=s3-(2*sprd); TP3=s3-(3*sprd);}
         else if ((hrg==s3))            {TP1=s3-(2*sprd); TP2=s3-(3*sprd); TP3=s3-(4*sprd);}
         else if ((hrg<s3))             {TP1=s3-(2*sprd); TP2=s3-(3*sprd); TP3=s3-(4*sprd);}
       }
   
   Write_SW("TPSU01", 0, 110, 6, Symbol() + " M" + Period() + " Open Status " + OpenStatus, 10, "Arial", TextColor);
   Write_SW("TPSU02", 0, 320, 6, "TP1 = " + DoubleToStr(TP1, Digits), 10, "Arial", TP1_color);
   Write_SW("TPSU03", 0, 410, 6, "TP2 = " + DoubleToStr(TP2, Digits), 10, "Arial", TP2_color);
   Write_SW("TPSU04", 0, 500, 6, "TP3 = " + DoubleToStr(TP3, Digits), 10, "Arial", TP3_color);
   
   Draw_H_Line("TPSU05",  TP1, TP1_color);
   Label_H_Line("TPSU06", TP1, " TP1 ", TP1_color);
   
   Draw_H_Line("TPSU07",  TP2, TP2_color);
   Label_H_Line("TPSU08", TP2, " TP2 ", TP2_color);
   
   Draw_H_Line("TPSU09",  TP3, TP3_color);
   Label_H_Line("TPSU10", TP3, " TP3 ", TP3_color);
   
   //Write_SW("TPSU02", 0, 220, 20, "TP1 = " + DoubleToStr(TP1, Digits), 10, "Arial", TextColor);
   //Write_SW("TPSU03", 0, 310, 20, "TP2 = " + DoubleToStr(TP2, Digits), 10, "Arial", TextColor);
   //Write_SW("TPSU04", 0, 400, 20, "TP3 = " + DoubleToStr(TP3, Digits), 10, "Arial", TextColor);
   //Write_SW("TPSU05", 0, 490, 20, "SPRD = " + DoubleToStr(sprd, Digits), 10, "Arial", TextColor);
//----
   return(0);
  }
  
// +------------------------------------------------------------------+
// ***************************************************************************************************
// ***************************************************************************************************
// Write_SW Procedure
void Write_SW(string LBL, double side, int pos_x, int pos_y, string text, int fontsize, string fontname, color txtcolor=CLR_NONE)
     {
       //Label_Teks=LBL;
       ObjectCreate(LBL, OBJ_LABEL, WindowFind(WindowName), 0, 0);
       ObjectSetText(LBL,text, fontsize, fontname, txtcolor);
       ObjectSet(LBL, OBJPROP_CORNER, side);
       ObjectSet(LBL, OBJPROP_XDISTANCE, pos_x);
       ObjectSet(LBL, OBJPROP_YDISTANCE, pos_y);
     }
     
     
// Draw_H_Line Procedure     
void Draw_H_Line(string Label_name, double Position, color Line_color)
       {
        ObjectDelete(Label_name);
        ObjectCreate(Label_name, OBJ_HLINE,0, CurTime(), Position);
        ObjectSet(Label_name, OBJPROP_COLOR, Line_color);
        ObjectSet(Label_name, OBJPROP_STYLE, STYLE_SOLID);
        ObjectSet(Label_name, OBJPROP_WIDTH, 1);
       }

// Label_H_Line Procedure  
void Label_H_Line (string LabelLine, double Pos_Label, string Text_Label, color Label_color)
          {
            if (ObjectFind(LabelLine) != 0)
               {
                ObjectCreate(LabelLine, OBJ_TEXT, 0, Time[10], Pos_Label);
                ObjectSetText(LabelLine, Text_Label, 9, "Verdana", Label_color);
               }
            else
              {
               ObjectMove(LabelLine, 0, Time[10], Pos_Label);
              }
          }            